
teleports = {}

function GetRequiredVersion()
	return 200
end

function OnScriptLoad(process, game, persistent)
	profilepath = getprofilepath()
	if game == "PC" or game == true then
		Map = readstring(0x698F21)
	else
		Map = readstring(0x61D151)
	end
	teleports[Map] = {}
	local file = io.open(profilepath .. "\\data\\locations.data", "r")
	if file then
		for line in file:lines() do
			local word = tokenizestring(line, ",")
			if Map == word[5] then
				teleports[Map][word[1]] = {}
				teleports[Map][word[1]].x = word[2]
				teleports[Map][word[1]].y = word[3]
				teleports[Map][word[1]].z = word[4]
				teleports[Map][word[1]].map = word[5]
			end
		end
		file:close()
	end
end

function OnScriptUnload()
	local file = io.open(profilepath .. "\\data\\locations.data", "w")
	for k,v in pairs(teleports[Map]) do
		if teleports[Map][k] then
			file:write(k .. "," .. teleports[Map][k].x .. "," .. teleports[Map][k].y .. "," .. teleports[Map][k].z .. "," .. teleports[Map][k].map)
		end
	end
end

function OnServerCommand(player, command)
	local response = nil
	local t = tokenizecmdstring(command)
	local count = #t
	if t[1] == "sv_teleport_add" then
		response = false
		Command_Setteleport(player, t[1], t[2], t[3], count)
	elseif t[1] == "sv_teleport_list" then
		response = false
		Command_TeleportList(player, t[1], count)
	elseif t[1] == "sv_teleport_del" then
		response = false
		Command_TeleportDelete(player, t[1], t[2], count)
	elseif t[1] == "sv_teleport" then
		response = false
		Command_Teleport(player, t[1], t[2], t[3], t[4], t[5], count)
	end
    return response
end

function Command_Setteleport(executor, command, locname, player, count)
	locname = tostring(locname)
	if count == 3 and not teleports[Map][locname] then
		local players = getvalidplayers(player, executor)
		if players then
			for i = 1,#players do
				local m_objectId = getplayerobjectid(players[i])
				if m_objectId then
					if getobject(m_objectId) then
						local x,y,z = getobjectcoords(m_objectId)
						teleports[Map] = teleports[Map] or {}
						teleports[Map][locname] = {}
						teleports[Map][locname].x = x
						teleports[Map][locname].y = y
						teleports[Map][locname].z = z
						teleports[Map][locname].map = Map
						sendresponse("Teleport location " .. locname .. " now corresponds to " .. getname(players[i]) .. "'s location", command, executor)
					else
						sendresponse("Cannot add teleport because the player is dead.", command, executor)
					end
				else
					sendresponse("Cannot add teleport because the player is dead.", command, executor)
				end
			end
		else
			sendresponse("Invalid Player", command, executor)
		end
	elseif count == 3 and teleports[Map][locname] then
		sendresponse(locname .. " is already added", command, executor)
	else
		sendresponse("Invalid Syntax: " .. command .. " [locname] [player]", command, executor)
	end
end

function Command_TeleportDelete(executor, command, location, count)
	if count == 2 then
		if teleports[Map][location] then
			teleports[Map][location] = nil
			sendresponse(location .. " has been deleted", command, executor)
		else
			sendresponse(location .. " does not exist", command, executor)
		end
	else
		sendresponse("Invalid Syntax: " .. command .. " [location name]", command, executor)
	end
end

function Command_TeleportList(executor, command, count)
	if count == 1 then
		local response = ""
		local bool = true
		for k,v in pairs(teleports[Map]) do
			if teleports[Map][k] then
				response = response .. "ID: " .. k .. "\n       -- X: ".. round(teleports[Map][k].x, 2) .. "  Y: " .. round(teleports[Map][k].y, 2) .. "  Z: " .. round(teleports[Map][k].z, 2) .. "\n"
				bool = false
			end
		end
		if bool then
			sendresponse("No teleports on this map", command, executor)
		else
			sendresponse(response, command, executor)
		end
	else
		sendresponse("Invalid Syntax: " .. command, command, executor)
	end
end

function Command_Teleport(executor, command, player, location, y, z, count)
	if count == 3 then
		local players = getvalidplayers(player, executor) 
		if players then
			for i = 1,#players do
				if teleports[Map][location] then
					local m_objectId = getplayerobjectid(players[i])
					if m_objectId then
						movobjectcoords(m_objectId, tonumber(teleports[Map][location].x), tonumber(teleports[Map][location].y), tonumber(teleports[Map][location].z))
						sendresponse("Teleporting " .. getname(players[i]) .. " to location '" .. location .. "'", command, executor)
					else
						sendresponse("Player is not alive", command, executor)
					end
				else
					sendresponse("Location '" .. tostring(location) .. "' does not exist for this map", command, executor)
				end
			end
		else
			sendresponse("Invalid Player", command, executor)
		end
	elseif count == 5 then
			local players = getvalidplayers(player, executor) 
			if players then
				location = tonumber(location)
				y = tonumber(y)
				z = tonumber(z)
				if location and y and z then
					for i = 1,#players do
						local m_objectId = getplayerobjectid(players[i])
						if m_objectId then
							movobjectcoords(m_objectId, location, y, z)
							sendresponse("Teleporting " .. getname(players[i]), command, executor)
						else
							sendresponse("Player is not alive", command, executor)
						end
					end
				else
					sendresponse("Invalid Coordinates", command, executor)
				end
			else
				sendresponse("Invalid Player", command, executor)
			end
	else
		sendresponse("Invalid Syntax: " .. command .. " [player] [location] or [x] [y] [z]", command, executor)
	end
end

function getvalidplayers(expression, player)
	if cur_players ~= 0 then
		local players = {}
		if expression == "*" then
			for i = 0,15 do
				if getplayer(i) then
					table.insert(players, i)
				end
			end
		elseif expression == "me" then
			if player ~= nil and player ~= -1 and player then
				table.insert(players, player)
			end
		elseif string.sub(expression, 1, 3) == "red" then
			for i = 0,15 do
				if getplayer(i) then
					local player_team = readdword(getplayer(i) + 0x20)
					if player_team == 0 then
						table.insert(players, i)
					end
				end
			end
		elseif string.sub(expression, 1, 4) == "blue" then
			for i = 0,15 do
				if getplayer(i) then
					local player_team = readdword(getplayer(i) + 0x20)
					if player_team == 1 then
						table.insert(players, i)
					end
				end
			end
		elseif (tonumber(expression) or 0) >= 1 and (tonumber(expression) or 0) <= 16 then
			local expression = tonumber(expression)
			if rresolveplayer(expression) then
				table.insert(players, rresolveplayer(expression))
			end
		elseif expression == "random" or expression == "rand" then
			if cur_players == 1 and player ~= nil then 
				table.insert(players, player) 
				return players 
			end
			local bool = false
			while not bool do
				num = math.random(0, 15)
				if getplayer(num) and num ~= player then
					bool = true
				end
			end
			table.insert(players, num)
		end
		if players[1] then
			return players
		end
	end
	return false
end

function round(val, decimal)
	if (decimal) then
		return math.floor((val * 10^decimal) + 0.5) / (10^decimal)
	else
		return math.floor(val+0.5)
	end
end

function sendresponse(message, command, player)
	player = tonumber(player)
	if tonumber(player) and player ~= nil and player ~= -1 and player >= 0 and player < 16 then
		sendconsoletext(player, message)
	else
		hprintf(message)
	end
end